## wit 2.13a

=== Makefile ===

#####################################################################
##                 __            __ _ ___________                  ##
##                 \ \          / /| |____   ____|                 ##
##                  \ \        / / | |    | |                      ##
##                   \ \  /\  / /  | |    | |                      ##
##                    \ \/  \/ /   | |    | |                      ##
##                     \  /\  /    | |    | |                      ##
##                      \/  \/     |_|    |_|                      ##
##                                                                 ##
##                        Wiimms ISO Tools                         ##
##                      http://wit.wiimm.de/                       ##
##                                                                 ##
#####################################################################
##                                                                 ##
##   This file is part of the WIT project.                         ##
##   Visit http://wit.wiimm.de/ for project details and sources.   ##
##                                                                 ##
##   Copyright (c) 2009-2013 by Dirk Clemens <wiimm@wiimm.de>      ##
##                                                                 ##
#####################################################################

#----------------------------------------------------------------
# make manual: http://www.gnu.org/software/make/manual/make.html
#----------------------------------------------------------------

#-------------------------------------------------------------------------------
# global settings

#SHELL			= /bin/bash
SHELL			= /usr/bin/env bash

AUTHOR			= Dirk Clemens
TOOLSET_SHORT		= WIT
TOOLSET_LONG		= Wiimms ISO Tools

WIT_SHORT		= wit
WIT_LONG		= Wiimms ISO Tool
WWT_SHORT		= wwt
WWT_LONG		= Wiimms WBFS Tool
WDF_SHORT		= wdf
WDF_LONG		= Wiimms WDF Tool
WFUSE_SHORT		= wfuse
WFUSE_LONG		= Wiimms FUSE Tool

VERSION_NUM		= 2.13a
BETA_VERSION		= 0
			# 0:off  -1:"beta"  >0:"beta#"

URI_HOME		= http://wit.wiimm.de/
URI_DOWNLOAD		= http://wit.wiimm.de/download
URI_FILE		= http://wit.wiimm.de/file

ifeq ($(BETA_VERSION),0)
  URI_REPOS		= http://opensvn.wiimm.de/wii/trunk/wiimms-iso-tools/
  URI_VIEWVC		= http://wit.wiimm.de/r/viewvc
else
  URI_REPOS		= http://opensvn.wiimm.de/wii/branches/public/wiimms-iso-tools/
  URI_VIEWVC		= http://wit.wiimm.de/r/viewvc-beta
endif

URI_WDF			= http://wit.wiimm.de/r/wdf
URI_CISO		= http://wit.wiimm.de/r/ciso
URI_QTWITGUI		= http://wit.wiimm.de/r/qtwitgui
URI_WIIBAFU		= http://wit.wiimm.de/r/wiibafu
#URI_WCDWM		= http://wit.wiimm.de/r/wcdwm
#URI_WIIJMANAGER	= http://wit.wiimm.de/r/wiijman
URI_MACWITGUI		= http://wit.wiimm.de/r/mac-witgui
URI_GBATEMP		= http://gbatemp.net/index.php?showtopic=182236\#entry2286365
URI_DOWNLOAD_I386	= $(URI_DOWNLOAD)/$(DISTRIB_I386)
URI_DOWNLOAD_X86_64	= $(URI_DOWNLOAD)/$(DISTRIB_X86_64)
URI_DOWNLOAD_MAC	= $(URI_DOWNLOAD)/$(DISTRIB_MAC)
URI_DOWNLOAD_CYGWIN	= $(URI_DOWNLOAD)/$(DISTRIB_CYGWIN)
URI_TITLES		= http://gametdb.com/titles.txt

DOWNLOAD_DIR		= /cygdrive/n/www/wit.wiimm.de/download


DUMMY			:= $(shell $(SHELL) ./setup.sh)
include Makefile.setup

# format for logging messages, $1=job, $2=object, $3=more info
LOGFORMAT		:= *** %7s %-17s %s\n

#-------------------------------------------------------------------------------
# version+beta settings

ifeq ($(BETA_VERSION),0)
  BETA_SUFFIX	:=
else ifeq ($(BETA_VERSION),-1)
  BETA_SUFFIX	:= .beta
else
  BETA_SUFFIX	:= .beta$(BETA_VERSION)
endif

VERSION		:= $(VERSION_NUM)$(BETA_SUFFIX)

#-------------------------------------------------------------------------------
# compiler settings

PRE		?= 
CC		= $(PRE)gcc
CPP		= $(PRE)g++
STRIP		= $(PRE)strip

#-------------------------------------------------------------------------------
# files

DIR_LIST	=

RM_FILES	= *.{a,o,d,tmp,bak,exe} */*.{tmp,bak} */*/*.{tmp,bak}
RM_FILES2	= *.{iso,ciso,wdf,wbfs} templates.sed

MODE_FILE	= ./_mode.flag
MODE		= $(shell test -s $(MODE_FILE) && cat $(MODE_FILE))
RM_FILES	+= $(MODE_FILE)

# wbfs: files / size in GiB of WBFS partition / number of ISO files to copy
WBFS_FILE	?= a.wbfs
WBFS_FILES	?= $(WBFS_FILE) b.wbfs c.wbfs d.wbfs
WBFS_SIZE	?= 20
WBFS_COUNT	?= 4

#-------------------------------------------------------------------------------
# tools

MAIN_TOOLS	:= wit wwt wdf
TEST_TOOLS	:= wtest
EXTRA_TOOLS	:=

ifeq ($(HAVE_FUSE),1)
  MAIN_TOOLS	+= wfuse
else
  EXTRA_TOOLS	:= wfuse
endif

ALL_TOOLS	:= $(sort $(MAIN_TOOLS) $(TEST_TOOLS))
ALL_TOOLS_X	:= $(sort $(MAIN_TOOLS) $(TEST_TOOLS) $(EXTRA_TOOLS))

HELPER_TOOLS	:= gen-ui

WDF_TEST_LINKS	:= WdfCat UnWdf WdfCmp WdfDump Ciso CisoCat UnCiso Wbi
WDF_LINKS	:= wdf-cat wdf-dump

RM_FILES	+= $(ALL_TOOLS_X) $(HELPER_TOOLS) $(WDF_LINKS) $(WDF_TEST_LINKS)

#-------------------------------------------------------------------------------
# tool dependent options and objects

ifeq ($(STATIC),1)
    OPT_STATIC	:= -static
else
    OPT_STATIC	:=
endif

#---------------

TOPT_wit	:= $(OPT_STATIC)
TOPT_wwt	:= $(OPT_STATIC)
TOPT_wdf	:= $(OPT_STATIC)
TOPT_wfuse	:= -lfuse -lpthread -ldl

#TOPT_ALL	:= $(TOPT_wit) $(TOPT_wwt) $(TOPT_wdf) $(TOPT_wfuse)

#---------------

TOBJ_wit	:= wit-mix.o
TOBJ_wwt	:=
TOBJ_wdf	:=
TOBJ_wfuse	:=

TOBJ_ALL	:= $(TOBJ_wit) $(TOBJ_wwt) $(TOBJ_wdf) $(TOBJ_wfuse)

#-------------------------------------------------------------------------------
# sub libs

# libbz2
LIBBZ2_SRC	= $(shell echo src/libbz2/*.c)
LIBBZ2_OBJ	= $(patsubst %.c,%.o,$(LIBBZ2_SRC))

# lib summary
LIB_LIST	+= libbz2
LIB_OBJECTS	+= $(LIBBZ2_OBJ)
RM_FILES	+= $(foreach l,$(LIB_LIST),src/$(l)/*.{d,o})

#-------------------------------------------------------------------------------
# source files

UI_FILES	= ui.def
UI_FILES	+= $(patsubst %,ui-%.c,$(MAIN_TOOLS) $(EXTRA_TOOLS))
UI_FILES	+= $(patsubst %,ui-%.h,$(MAIN_TOOLS) $(EXTRA_TOOLS))

UI_TABS		= $(patsubst %,tab-%.inc,$(MAIN_TOOLS) $(EXTRA_TOOLS))

SETUP_DIR	=  ./setup
SETUP_INFO	=  INSTALL.txt
SETUP_FILES	=  version.h install.sh cygwin-copy.sh wit.def \
		   $(SETUP_INFO) $(CYGWIN_SCRIPTS)
DIR_LIST	+= $(SETUP_DIR)
RM_FILES2	+= $(SETUP_FILES)

TEXT_DIR	=  ./text-files
TEXT_FILES	=  logo.inc ui-head.inc
DIR_LIST	+= $(TEXT_DIR)
RM_FILES2	+= $(TEXT_FILES)

#-------------------------------------------------------------------------------
# object files

# objects of tools
MAIN_TOOLS_OBJ	:= $(patsubst %,%.o,$(MAIN_TOOLS) $(EXTRA_TOOLS))
OTHER_TOOLS_OBJ	:= $(patsubst %,%.o,$(TEST_TOOLS) $(HELPER_TOOLS))

# other objects
WIT_O		:= debug.o lib-std.o lib-file.o lib-sf.o \
		   lib-bzip2.o lib-lzma.o \
		   lib-wdf.o lib-wia.o lib-ciso.o \
		   ui.o iso-interface.o wbfs-interface.o patch.o \
		   titles.o match-pattern.o dclib-utf8.o \
		   sha1dgst.o sha1_one.o
LIBWBFS_O	:= tools.o file-formats.o libwbfs.o wiidisc.o cert.o rijndael.o
LZMA_O		:= LzmaDec.o LzmaEnc.o LzFind.o Lzma2Dec.o Lzma2Enc.o

ifeq ($(SYSTEM),cygwin)
WIT_O		+= winapi.o
endif

# object groups
UI_OBJECTS	:= $(sort $(MAIN_TOOLS_OBJ))
C_OBJECTS	:= $(sort $(OTHER_TOOLS_OBJ) $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(TOBJ_ALL))
ASM_OBJECTS	:= ssl-asm.o

# all objects + sources
ALL_OBJECTS	= $(sort $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(ASM_OBJECTS) $(LIB_OBJECTS))
ALL_SOURCES	= $(patsubst %.o,%.c,$(UI_OBJECTS) $(C_OBJECTS) $(ASM_OBJECTS))

#-------------------------------------------------------------------------------

SHARE_PATH	= $(INSTALL_PATH)/share/wit
INSTALL_SCRIPTS	= install.sh load-titles.sh
RM_FILES	+= $(INSTALL_SCRIPTS)
SCRIPTS		= ./scripts
TEMPLATES	= ./templates
MODULES		= $(TEMPLATES)/module
GEN_TEMPLATE	= ./gen-template.sh
GEN_TEXT_FILE	= ./gen-text-file.sh
UI		= ./src/ui
DIR_LIST	+= $(SCRIPTS) $(TEMPLATES) $(MODULES)

VPATH		+= src src/libwbfs src/lzma src/crypto $(UI) work
DIR_LIST	+= src src/libwbfs src/lzma src/crypto $(UI) work

DEFINES1	+= -DLARGE_FILES -D_FILE_OFFSET_BITS=64
DEFINES1	+= -DWIT		# compile wit tools (for shared sources (e.g. libwbfs))
DEFINES1	+= -DDEBUG_ASSERT	# enable ASSERTions in release version too
DEFINES1	+= -DEXTENDED_ERRORS=1	# enable extended error messages (function,line,file)
DEFINES1	+= -D_7ZIP_ST=1		# disable 7zip multi threading
DEFINES1	+= -D_LZMA_PROB32=1	# LZMA option
DEFINES		=  $(strip $(DEFINES1) $(MODE) $(XDEF))

CFLAGS		+= -fomit-frame-pointer -fno-strict-aliasing -funroll-loops
CFLAGS		+= -Wall -Wno-parentheses -Wno-unused-function
CFLAGS		+= -O3 -Isrc/libwbfs -Isrc/lzma -Isrc -I$(UI) -I. -Iwork
ifeq ($(SYSTEM),mac)
 CFLAGS		+= -I/usr/local/include
endif
CFLAGS		+= $(XFLAGS)
CFLAGS		:= $(strip $(CFLAGS))

DEPFLAGS	+= -MMD

LDFLAGS		+= -static-libgcc
LDFLAGS		:= $(strip $(LDFLAGS))

LIBS		+= $(XLIBS)

DISTRIB_RM	= ./wit-v$(VERSION)-r
DISTRIB_BASE	= wit-v$(VERSION)-r$(REVISION_NEXT)
DISTRIB_PATH	= ./$(DISTRIB_BASE)-$(SYSTEM)
DISTRIB_I386	= $(DISTRIB_BASE)-i386.tar.gz
DISTRIB_X86_64	= $(DISTRIB_BASE)-x86_64.tar.gz
DISTRIB_MAC	= $(DISTRIB_BASE)-mac.tar.gz
DISTRIB_CYGWIN	= $(DISTRIB_BASE)-cygwin.zip
DISTRIB_FILES	= gpl-2.0.txt $(INSTALL_SCRIPTS) $(SETUP_INFO)

DOC_FILES	= doc/*.txt
IGNORE_DOC_FILES= HISTORY-v*.txt
TITLE_FILES	= titles.txt $(patsubst %,titles-%.txt,$(LANGUAGES))
LANGUAGES	= de es fr it ja ko nl pt ru zhcn zhtw

BIN_FILES	= $(MAIN_TOOLS) $(EXTRA_TOOLS)
SHARE_FILES	= $(TITLE_FILES) system-menu.txt magic.txt

CYGWIN_DIR	= /usr/bin
CYGWIN_TOOLS	= bash cp diff env grep mkdir mv realpath regtool rm stat tr wget
CYGWIN_SCRIPTS	= load-titles.sh load-titles.bat \
		  windows-install.sh windows-uninstall.sh
CYGWIN_INSTALLER= $(SETUP_DIR)/windows-install.exe

WIN_INSTALL_PATH= Wiimm/WIT

DIR_LIST_BIN	= $(SCRIPTS) bin
DIR_LIST	+= $(DIR_LIST_BIN)
DIR_LIST	+= share work pool makefiles-local edit-list


#-------------------------------------------------------------------------------
# sub projects

SUB_PROJECTS	+= test-libwbfs
RM_FILES	+= $(foreach p,$(SUB_PROJECTS),$(p)/*.{d,o} $(p)/$(p))

#
###############################################################################
# default rule

default_rule: all
	@echo "HINT: try 'make help'"

# include this behind the default rule
-include $(ALL_SOURCES:.c=.d)

#
###############################################################################
# general rules

$(ALL_TOOLS_X): %: %.o $(ALL_OBJECTS) $(TOBJ_ALL) Makefile | $(HELPER_TOOLS)
	@printf "$(LOGFORMAT)" tool "$@" "$(MODE) $(TOPT_$@) $(TOBJ_$@)"
	@$(CC) $(CFLAGS) $(DEFINES) $(LDFLAGS) $@.o \
		$(ALL_OBJECTS) $(TOBJ_$@) $(LIBS) $(TOPT_$@) -o $@
	@if test -f $@.exe; then $(STRIP) $@.exe; else $(STRIP) $@; fi

	@mkdir -p bin/$(SYSTEM) bin/$(SYSTEM)/debug
	@if test -s $(MODE_FILE) && grep -Fq -e -DDEBUG $(MODE_FILE); \
		then cp -p $@ bin/$(SYSTEM)/debug/; \
		else cp -p $@ bin/; cp -p $@ bin/$(SYSTEM)/; fi

#--------------------------

$(HELPER_TOOLS): %: %.o $(ALL_OBJECTS) $(UI_TABS) Makefile
	@printf "$(LOGFORMAT)" helper "$@ $(TOBJ_$@)" "$(MODE)"
	@$(CC) $(CFLAGS) $(DEFINES) $(LDFLAGS) $@.o \
		$(ALL_OBJECTS) $(TOBJ_$@) $(LIBS) -o $@

#--------------------------

$(WDF_LINKS): wdf
	@printf "$(LOGFORMAT)" "link" "wdf -> $@" ""
	@ln -f wdf "$@"

#--------------------------

$(UI_OBJECTS): %.o: %.c ui-%.c ui-%.h version.h Makefile
	@printf "$(LOGFORMAT)" +object "$@" "$(MODE)"
	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@

#--------------------------

$(C_OBJECTS): %.o: %.c version.h Makefile $(TEXT_FILES)
	@printf "$(LOGFORMAT)" object "$@" "$(MODE)"
	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@

#--------------------------

$(ASM_OBJECTS): %.o: %.S Makefile
	@printf "$(LOGFORMAT)" asm "$@" "$(MODE)"
	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@

#--------------------------

$(SETUP_FILES): templates.sed $(SETUP_DIR)/$@
	@printf "$(LOGFORMAT)" create "$@" ""
	@chmod 775 $(GEN_TEMPLATE)
	@$(GEN_TEMPLATE) $@

#--------------------------

$(TEXT_FILES): $(GEN_TEXT_FILE) $(TEXT_DIR)/$@
	@printf "$(LOGFORMAT)" text "$@" ""
	@chmod 775 $(GEN_TEXT_FILE)
	@$(GEN_TEXT_FILE) $(TEXT_DIR) $@

#--------------------------

=== debian/changelog ===
wit (2.13a-1) unstable; urgency=low

  * New upstream release.
  * experimental to unstable to correct my mistake when initially uploading
    the package. I thought it belonged to experimental because of the freeze
    but that’s not true, since it’s a new package.

 -- Michael Stapelberg <stapelberg@debian.org>  Sat, 30 Mar 2013 11:59:36 +0100

wit (2.10a-1) experimental; urgency=low

  * Initial release (Closes: #697145)

 -- Michael Stapelberg <stapelberg@debian.org>  Tue, 01 Jan 2013 22:11:11 +0100

=== debian/control ===
Source: wit
Section: utils
Priority: extra
Maintainer: Michael Stapelberg <stapelberg@debian.org>
Build-Depends: debhelper (>= 8.0.0), dpkg-dev (>= 1.16.1~), libmhash-dev, libbz2-dev, libfuse-dev
Standards-Version: 3.9.4
Homepage: http://wit.wiimm.de/
Vcs-Git: git://git.debian.org/collab-maint/wit.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/wit.git;a=summary

Package: wit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: manipulate Wii and GameCube ISO images and WBFS containers
 Wiimms ISO Tools is a set of command line tools to manipulate Wii and GameCube
 ISO images and WBFS containers. The toolset consists of the following tools:
 .
 wit (Wiimms ISO Tool):
 This is the main ISO manipulation tool : It can list, analyze, verify,
 convert, split, join, patch, mix, extract, compose, rename and compare Wii and
 GameCube discs. It can create and dump different other Wii file formats.
 .
 wwt (Wiimms WBFS Tool):
 This is the main WBFS manipulation tool (WBFS manager) : It can create, check,
 repair, verify and clone WBFS files and partitions. It can list, add, extract,
 remove, rename and recover ISO images as part of a WBFS.
 .
 wdf (Wiimms WDF Tool):
 wdf is a support tool for WDF, WIA and CISO archives. It convert (pack and
 unpack), compare and dump WDF, WIA (dump and cat only) and CISO archives. The
 default command depends on the program file name (see command descriptions).
 Usual names are wdf, unwdf, wdf-cat, wdf-cmp and wdf-dump (with or without
 minus signs). »wdf +CAT« replaces the old tool wdf-cat and »wdf +DUMP« the old
 tool wdf-dump.
 .
 wfuse (Wiimms FUSE Tool):
 Mount a Wii or GameCube image or a WBFS file or partition to a mount point
 using FUSE (Filesystem in USErspace). Use 'wfuse --umount mountdir' for
 unmounting.

## wit 2.22b

=== Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 WFUSE_SHORT		= wfuse
 WFUSE_LONG		= Wiimms FUSE Tool
 
-VERSION_NUM		= 2.13a
+VERSION_NUM		= 2.22b
 BETA_VERSION		= 0
 			# 0:off  -1:"beta"  >0:"beta#"

=== test-libwbfs/Makefile ===
#----------------------------------------------------------------
# make manual: http://www.gnu.org/software/make/manual/make.html
#----------------------------------------------------------------

#-------------------------------------------------------------------------------
# global settings

SHELL			= /bin/bash

PRE		?= 
CC		= $(PRE)gcc
CPP		= $(PRE)g++
STRIP		= $(PRE)strip

#-------------------------------------------------------------------------------
# files

RM_FILES	= *.{o,d,tmp,bak,exe}

#-------------------------------------------------------------------------------
# tools

TOOLS		:= test-libwbfs
RM_FILES	+= $(TOOLS)

#-------------------------------------------------------------------------------
# object files

# objects of tools
TOOLS_O	:= $(patsubst %,%.o,$(TOOLS))

# other objects
LIBWBFS_O	:= file-formats.o libwbfs.o wiidisc.o rijndael.o

# object groups
C_OBJECTS	:= $(sort $(TOOLS_O) $(LIBWBFS_O))

# all objects + sources
ALL_OBJECTS	:= $(sort $(LIBWBFS_O))
ALL_SOURCES	:= $(patsubst %.o,%.c,$(ALL_OBJECTS))

#-------------------------------------------------------------------------------

VPATH		+= ../src/libwbfs

DEFINES		=  -DLARGE_FILES -D_FILE_OFFSET_BITS=64 $(XDEF)
DEFINES		:= $(strip $(DEFINES))

CFLAGS		=  -fomit-frame-pointer -fno-strict-aliasing
CFLAGS		+= -Wall -Wno-parentheses -Wno-unused-function
CFLAGS		+= -O3 -I../src/libwbfs -I.
CFLAGS		+= $(XFLAGS)
CFLAGS		:= $(strip $(CFLAGS))

DEPFLAGS	+= -MMD

LDFLAGS		+= -static-libgcc
#LDFLAGS	+= -static
LDFLAGS		:= $(strip $(LDFLAGS))

LIBS		+= $(XLIBS)

#
###############################################################################
# default rule

default_rule: all
#	@echo "HINT: try 'make help'"

# include this behind the default rule
-include $(ALL_SOURCES:.c=.d)

#
###############################################################################
# general rules

$(TOOLS): %: %.o $(ALL_OBJECTS) Makefile
	@echo "***    tool $@ $(MODE)"
	@$(CC) $(CFLAGS) $(DEFINES) $(LDFLAGS) $@.o $(ALL_OBJECTS) $(LIBS) -o $@
	@if test -f $@.exe; then $(STRIP) $@.exe; else $(STRIP) $@; fi

#--------------------------

$(C_OBJECTS): %.o: %.c Makefile
	@echo "***  object $@ $(MODE)"
	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@

#--------------------------

$(ASM_OBJECTS): %.o: %.S Makefile
	@echo "***     asm $@ $(MODE)"
	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@

#
###############################################################################
# specific rules in alphabetic order

.PHONY : all
all: $(TOOLS)

.PHONY : all+
all+: clean all

#
#--------------------------

.PHONY : clean
clean:
	@echo "***      rm output files"
	@rm -f $(RM_FILES)

#
#--------------------------

.PHONY : flags
flags:
	@echo  ""
	@echo  "DEFINES: $(DEFINES)"
	@echo  ""
	@echo  "CFLAGS:  $(CFLAGS)"
	@echo  ""
	@echo  "LDFLAGS: $(LDFLAGS)"
	@echo  ""
	@echo  "LIBS: $(LIBS)"
	@echo  ""

#
#--------------------------

.PHONY : tools
tools: $(ALL_TOOLS)

=== debian/changelog ===
wit (2.22b-1) unstable; urgency=low

  * New upstream release.
  * Fix search path to be /usr/share/wit instead of /usr/local/share/wit
    (Closes: #708010)
  * Canonicalize Vcs-* fields

 -- Michael Stapelberg <stapelberg@debian.org>  Thu, 11 Jul 2013 23:11:19 +0200

## wit 2.31a

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 ##   This file is part of the WIT project.                         ##
 ##   Visit http://wit.wiimm.de/ for project details and sources.   ##
 ##                                                                 ##
-##   Copyright (c) 2009-2013 by Dirk Clemens <wiimm@wiimm.de>      ##
+##   Copyright (c) 2009-2015 by Dirk Clemens <wiimm@wiimm.de>      ##
 ##                                                                 ##
 #####################################################################
 
@@ -43,7 +43,7 @@
 WFUSE_SHORT		= wfuse
 WFUSE_LONG		= Wiimms FUSE Tool
 
-VERSION_NUM		= 2.22b
+VERSION_NUM		= 2.31a
 BETA_VERSION		= 0
 			# 0:off  -1:"beta"  >0:"beta#"
 
@@ -174,14 +174,26 @@
 #-------------------------------------------------------------------------------
 # sub libs
 
-# libbz2
+# libbz2 & lzma
 LIBBZ2_SRC	= $(shell echo src/libbz2/*.c)
 LIBBZ2_OBJ	= $(patsubst %.c,%.o,$(LIBBZ2_SRC))
 
+LZMA_SRC	= $(shell echo src/lzma/*.c)
+LZMA_OBJ	= $(patsubst %.c,%.o,$(LZMA_SRC))
+
+ifeq ($(SYSTEM),cygwin)
+  LZMA_FLAGS	= -Wno-unused-but-set-variable
+  BZIP2_FLAGS	= -Wno-maybe-uninitialized
+else
+  LZMA_FLAGS	=
+  BZIP2_FLAGS	=
+endif
+
 # lib summary
-LIB_LIST	+= libbz2
-LIB_OBJECTS	+= $(LIBBZ2_OBJ)
+LIB_LIST	+= libbz2 lzma
+LIB_OBJECTS	+= $(LIBBZ2_OBJ) $(LZMA_OBJ)
 RM_FILES	+= $(foreach l,$(LIB_LIST),src/$(l)/*.{d,o})
+
 
 #-------------------------------------------------------------------------------
 # source files
@@ -214,12 +226,11 @@
 # other objects
 WIT_O		:= debug.o lib-std.o lib-file.o lib-sf.o \
 		   lib-bzip2.o lib-lzma.o \
-		   lib-wdf.o lib-wia.o lib-ciso.o \
+		   lib-wdf.o lib-wia.o lib-ciso.o lib-gcz.o \
 		   ui.o iso-interface.o wbfs-interface.o patch.o \
 		   titles.o match-pattern.o dclib-utf8.o \
 		   sha1dgst.o sha1_one.o
 LIBWBFS_O	:= tools.o file-formats.o libwbfs.o wiidisc.o cert.o rijndael.o
-LZMA_O		:= LzmaDec.o LzmaEnc.o LzFind.o Lzma2Dec.o Lzma2Enc.o
 
 ifeq ($(SYSTEM),cygwin)
 WIT_O		+= winapi.o
@@ -227,11 +238,13 @@
 
 # object groups
 UI_OBJECTS	:= $(sort $(MAIN_TOOLS_OBJ))
-C_OBJECTS	:= $(sort $(OTHER_TOOLS_OBJ) $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(TOBJ_ALL))
+#C_OBJECTS	:= $(sort $(OTHER_TOOLS_OBJ) $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(TOBJ_ALL))
+C_OBJECTS	:= $(sort $(OTHER_TOOLS_OBJ) $(WIT_O) $(LIBWBFS_O) $(TOBJ_ALL))
 ASM_OBJECTS	:= ssl-asm.o
 
 # all objects + sources
-ALL_OBJECTS	= $(sort $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(ASM_OBJECTS) $(LIB_OBJECTS))
+#ALL_OBJECTS	= $(sort $(WIT_O) $(LIBWBFS_O) $(LZMA_O) $(ASM_OBJECTS) $(LIB_OBJECTS))
+ALL_OBJECTS	= $(sort $(WIT_O) $(LIBWBFS_O) $(ASM_OBJECTS) $(LIB_OBJECTS))
 ALL_SOURCES	= $(patsubst %.o,%.c,$(UI_OBJECTS) $(C_OBJECTS) $(ASM_OBJECTS))
 
 #-------------------------------------------------------------------------------
@@ -247,8 +260,10 @@
 UI		= ./src/ui
 DIR_LIST	+= $(SCRIPTS) $(TEMPLATES) $(MODULES)
 
-VPATH		+= src src/libwbfs src/lzma src/crypto $(UI) work
-DIR_LIST	+= src src/libwbfs src/lzma src/crypto $(UI) work
+#VPATH		+= src src/libwbfs src/lzma src/crypto $(UI) work
+#DIR_LIST	+= src src/libwbfs src/lzma src/crypto $(UI) work
+VPATH		+= src src/libwbfs src/crypto $(UI) work
+DIR_LIST	+= src src/libwbfs src/crypto $(UI) work
 
 DEFINES1	+= -DLARGE_FILES -D_FILE_OFFSET_BITS=64
 DEFINES1	+= -DWIT		# compile wit tools (for shared sources (e.g. libwbfs))
@@ -260,7 +275,8 @@
 
 CFLAGS		+= -fomit-frame-pointer -fno-strict-aliasing -funroll-loops
 CFLAGS		+= -Wall -Wno-parentheses -Wno-unused-function
-CFLAGS		+= -O3 -Isrc/libwbfs -Isrc/lzma -Isrc -I$(UI) -I. -Iwork
+#CFLAGS		+= -O3 -Isrc/libwbfs -Isrc/lzma -Isrc -I$(UI) -I. -Iwork
+CFLAGS		+= -O3 -Isrc/libwbfs -Isrc -I$(UI) -I. -Iwork
 ifeq ($(SYSTEM),mac)
  CFLAGS		+= -I/usr/local/include
 endif
@@ -272,6 +288,9 @@
 LDFLAGS		+= -static-libgcc
 LDFLAGS		:= $(strip $(LDFLAGS))
 
+ifeq ($(HAVE_ZLIB),1)
+ LIBS		+= -lz
+endif
 LIBS		+= $(XLIBS)
 
 DISTRIB_RM	= ./wit-v$(VERSION)-r
@@ -360,27 +379,3 @@
 
 $(C_OBJECTS): %.o: %.c version.h Makefile $(TEXT_FILES)
 	@printf "$(LOGFORMAT)" object "$@" "$(MODE)"
-	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@
-
-#--------------------------
-
-$(ASM_OBJECTS): %.o: %.S Makefile
-	@printf "$(LOGFORMAT)" asm "$@" "$(MODE)"
-	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@
-
-#--------------------------
-
-$(SETUP_FILES): templates.sed $(SETUP_DIR)/$@
-	@printf "$(LOGFORMAT)" create "$@" ""
-	@chmod 775 $(GEN_TEMPLATE)
-	@$(GEN_TEMPLATE) $@
-
-#--------------------------
-
-$(TEXT_FILES): $(GEN_TEXT_FILE) $(TEXT_DIR)/$@
-	@printf "$(LOGFORMAT)" text "$@" ""
-	@chmod 775 $(GEN_TEXT_FILE)
-	@$(GEN_TEXT_FILE) $(TEXT_DIR) $@
-
-#--------------------------
-

=== debian/changelog ===
wit (2.31a-3) unstable; urgency=medium

  [ Chris Lamb ]
  * Fix for “wit: please make the build reproducible” (Closes: #831331)

 -- Michael Stapelberg <stapelberg@debian.org>  Sun, 17 Jul 2016 13:32:41 +0200

wit (2.31a-2) unstable; urgency=low

  [ Tobias Gruetzmacher ]
  * Add zlib support (Closes: #815710)
  * Don’t link wfuse against libdl

 -- Michael Stapelberg <stapelberg@debian.org>  Tue, 23 Feb 2016 23:40:46 +0100

wit (2.31a-1) unstable; urgency=low

  * New upstream release. (Closes: #813732)

 -- Michael Stapelberg <stapelberg@debian.org>  Mon, 08 Feb 2016 09:18:04 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: utils
 Priority: extra
 Maintainer: Michael Stapelberg <stapelberg@debian.org>
-Build-Depends: debhelper (>= 8.0.0), dpkg-dev (>= 1.16.1~), libmhash-dev, libbz2-dev, libfuse-dev
+Build-Depends: debhelper (>= 8.0.0), dpkg-dev (>= 1.16.1~), libmhash-dev, libbz2-dev, libfuse-dev, zlib1g-dev
 Standards-Version: 3.9.4
 Homepage: http://wit.wiimm.de/
-Vcs-Git: git://git.debian.org/collab-maint/wit.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/wit.git;a=summary
+Vcs-Git: git://anonscm.debian.org/collab-maint/wit.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/wit.git;a=summary
 
 Package: wit
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# The Makefile doesn’t use CPPFLAGS
export XDEF=$(shell dpkg-buildflags --get CPPFLAGS)

override_dh_auto_clean:
	$(MAKE) clean+
	rm -rf bin
	rm -rf Makefile.setup

# Skip testing, "make test" does not actually run a testsuite.
override_dh_auto_test:

override_dh_auto_build:
	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr HAVE_ZLIB=1
	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr doc

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/wit/usr/bin
	mkdir -p $(CURDIR)/debian/wit/usr/share
	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr install

override_dh_installchangelogs:
	dh_installchangelogs doc/HISTORY.txt

%:
	dh $@

=== debian/watch ===
version=3
http://wit.wiimm.de/download.html /download/wit-v([^-]+)-.*i386.tar.gz

## wit 3.01a

=== Makefile ===
--- 
+++ 
@@ -9,14 +9,14 @@
 ##                      \/  \/     |_|    |_|                      ##
 ##                                                                 ##
 ##                        Wiimms ISO Tools                         ##
-##                      http://wit.wiimm.de/                       ##
+##                      https://wit.wiimm.de/                       ##
 ##                                                                 ##
 #####################################################################
 ##                                                                 ##
 ##   This file is part of the WIT project.                         ##
-##   Visit http://wit.wiimm.de/ for project details and sources.   ##
-##                                                                 ##
-##   Copyright (c) 2009-2015 by Dirk Clemens <wiimm@wiimm.de>      ##
+##   Visit https://wit.wiimm.de/ for project details and sources.   ##
+##                                                                 ##
+##   Copyright (c) 2009-2017 by Dirk Clemens <wiimm@wiimm.de>      ##
 ##                                                                 ##
 #####################################################################
 
@@ -26,6 +26,8 @@
 
 #-------------------------------------------------------------------------------
 # global settings
+
+MYMAKE			:= $(lastword $(MAKEFILE_LIST))
 
 #SHELL			= /bin/bash
 SHELL			= /usr/bin/env bash
@@ -43,29 +45,29 @@
 WFUSE_SHORT		= wfuse
 WFUSE_LONG		= Wiimms FUSE Tool
 
-VERSION_NUM		= 2.31a
+VERSION_NUM		= 3.01a
 BETA_VERSION		= 0
 			# 0:off  -1:"beta"  >0:"beta#"
 
-URI_HOME		= http://wit.wiimm.de/
-URI_DOWNLOAD		= http://wit.wiimm.de/download
-URI_FILE		= http://wit.wiimm.de/file
+URI_HOME		= https://wit.wiimm.de/
+URI_DOWNLOAD		= https://wit.wiimm.de/download
+URI_FILE		= https://wit.wiimm.de/file
 
 ifeq ($(BETA_VERSION),0)
   URI_REPOS		= http://opensvn.wiimm.de/wii/trunk/wiimms-iso-tools/
-  URI_VIEWVC		= http://wit.wiimm.de/r/viewvc
+  URI_VIEWVC		= https://wit.wiimm.de/r/viewvc
 else
   URI_REPOS		= http://opensvn.wiimm.de/wii/branches/public/wiimms-iso-tools/
-  URI_VIEWVC		= http://wit.wiimm.de/r/viewvc-beta
-endif
-
-URI_WDF			= http://wit.wiimm.de/r/wdf
-URI_CISO		= http://wit.wiimm.de/r/ciso
-URI_QTWITGUI		= http://wit.wiimm.de/r/qtwitgui
-URI_WIIBAFU		= http://wit.wiimm.de/r/wiibafu
-#URI_WCDWM		= http://wit.wiimm.de/r/wcdwm
-#URI_WIIJMANAGER	= http://wit.wiimm.de/r/wiijman
-URI_MACWITGUI		= http://wit.wiimm.de/r/mac-witgui
+  URI_VIEWVC		= https://wit.wiimm.de/r/viewvc-beta
+endif
+
+URI_WDF			= https://wit.wiimm.de/r/wdf
+URI_CISO		= https://wit.wiimm.de/r/ciso
+URI_QTWITGUI		= https://wit.wiimm.de/r/qtwitgui
+URI_WIIBAFU		= https://wit.wiimm.de/r/wiibafu
+#URI_WCDWM		= https://wit.wiimm.de/r/wcdwm
+#URI_WIIJMANAGER	= https://wit.wiimm.de/r/wiijman
+URI_MACWITGUI		= https://wit.wiimm.de/r/mac-witgui
 URI_GBATEMP		= http://gbatemp.net/index.php?showtopic=182236\#entry2286365
 URI_DOWNLOAD_I386	= $(URI_DOWNLOAD)/$(DISTRIB_I386)
 URI_DOWNLOAD_X86_64	= $(URI_DOWNLOAD)/$(DISTRIB_X86_64)
@@ -73,14 +75,25 @@
 URI_DOWNLOAD_CYGWIN	= $(URI_DOWNLOAD)/$(DISTRIB_CYGWIN)
 URI_TITLES		= http://gametdb.com/titles.txt
 
-DOWNLOAD_DIR		= /cygdrive/n/www/wit.wiimm.de/download
-
+DOWNLOAD_DIR		= /n/www/wit.wiimm.de/download
+EXPORT_DIR		= /cygdrive/n/wit/wiimms-iso-tools/bin
 
 DUMMY			:= $(shell $(SHELL) ./setup.sh)
 include Makefile.setup
 
+#------------------------------------------------------------------------------
 # format for logging messages, $1=job, $2=object, $3=more info
-LOGFORMAT		:= *** %7s %-17s %s\n
+
+LOGFORMAT		:= \33[36;1m*** %7s %-17s %s\33[0m\n
+LOGFORMAT_CC		:= \33[33;1m*** %7s %-17s %s\33[0m\n
+LOGFORMAT_TOOL		:= \33[35;1m*** %7s %-17s %s\33[0m\n
+LOGFORMAT_INST		:= \33[32;1m*** %7s %-17s %s\33[0m\n
+
+#------------------------------------------------------------------------------
+# include source library definitions
+
+DCLIB_MYSQL := 0
+include ./dclib/Makefile.inc
 
 #-------------------------------------------------------------------------------
 # version+beta settings
@@ -148,7 +161,7 @@
 # tool dependent options and objects
 
 ifeq ($(STATIC),1)
-    OPT_STATIC	:= -static
+    OPT_STATIC	:= -static -DDCLIB_STATIC=1
 else
     OPT_STATIC	:=
 endif
@@ -184,9 +197,12 @@
 ifeq ($(SYSTEM),cygwin)
   LZMA_FLAGS	= -Wno-unused-but-set-variable
   BZIP2_FLAGS	= -Wno-maybe-uninitialized
-else
-  LZMA_FLAGS	=
-  BZIP2_FLAGS	=
+else ifeq ($(SYSTEM),mac)
+  LZMA_FLAGS	= 
+  BZIP2_FLAGS	= 
+else
+  LZMA_FLAGS	= -Wno-unused-but-set-variable
+  BZIP2_FLAGS	= -Wno-maybe-uninitialized
 endif
 
 # lib summary
@@ -223,13 +239,21 @@
 MAIN_TOOLS_OBJ	:= $(patsubst %,%.o,$(MAIN_TOOLS) $(EXTRA_TOOLS))
 OTHER_TOOLS_OBJ	:= $(patsubst %,%.o,$(TEST_TOOLS) $(HELPER_TOOLS))
 
+# dclib
+DCLIB_DIR	:= ./dclib
+DIR_LIST	+= $(DCLIB_DIR)
+VPATH		+= $(DCLIB_DIR)
+CFLAGS		+= -I$(DCLIB_DIR)
+
 # other objects
-WIT_O		:= debug.o lib-std.o lib-file.o lib-sf.o \
+WIT_O		:= lib-std.o lib-file.o lib-sf.o \
 		   lib-bzip2.o lib-lzma.o \
 		   lib-wdf.o lib-wia.o lib-ciso.o lib-gcz.o \
-		   ui.o iso-interface.o wbfs-interface.o patch.o \
+		   iso-interface.o wbfs-interface.o patch.o \
 		   titles.o match-pattern.o dclib-utf8.o \
-		   sha1dgst.o sha1_one.o
+		   sha1dgst.o sha1_one.o \
+		   $(DCLIB_O)
+
 LIBWBFS_O	:= tools.o file-formats.o libwbfs.o wiidisc.o cert.o rijndael.o
 
 ifeq ($(SYSTEM),cygwin)
@@ -291,7 +315,7 @@
 ifeq ($(HAVE_ZLIB),1)
  LIBS		+= -lz
 endif
-LIBS		+= $(XLIBS)
+LIBS		+= -lm $(XLIBS)
 
 DISTRIB_RM	= ./wit-v$(VERSION)-r
 DISTRIB_BASE	= wit-v$(VERSION)-r$(REVISION_NEXT)
@@ -346,36 +370,10 @@
 # general rules
 
 $(ALL_TOOLS_X): %: %.o $(ALL_OBJECTS) $(TOBJ_ALL) Makefile | $(HELPER_TOOLS)
-	@printf "$(LOGFORMAT)" tool "$@" "$(MODE) $(TOPT_$@) $(TOBJ_$@)"
+	@printf "$(LOGFORMAT_TOOL)" tool "$@" "$(MODE) $(TOPT_$@) $(TOBJ_$@)"
 	@$(CC) $(CFLAGS) $(DEFINES) $(LDFLAGS) $@.o \
 		$(ALL_OBJECTS) $(TOBJ_$@) $(LIBS) $(TOPT_$@) -o $@
 	@if test -f $@.exe; then $(STRIP) $@.exe; else $(STRIP) $@; fi
 
 	@mkdir -p bin/$(SYSTEM) bin/$(SYSTEM)/debug
 	@if test -s $(MODE_FILE) && grep -Fq -e -DDEBUG $(MODE_FILE); \
-		then cp -p $@ bin/$(SYSTEM)/debug/; \
-		else cp -p $@ bin/; cp -p $@ bin/$(SYSTEM)/; fi
-
-#--------------------------
-
-$(HELPER_TOOLS): %: %.o $(ALL_OBJECTS) $(UI_TABS) Makefile
-	@printf "$(LOGFORMAT)" helper "$@ $(TOBJ_$@)" "$(MODE)"
-	@$(CC) $(CFLAGS) $(DEFINES) $(LDFLAGS) $@.o \
-		$(ALL_OBJECTS) $(TOBJ_$@) $(LIBS) -o $@
-
-#--------------------------
-
-$(WDF_LINKS): wdf
-	@printf "$(LOGFORMAT)" "link" "wdf -> $@" ""
-	@ln -f wdf "$@"
-
-#--------------------------
-
-$(UI_OBJECTS): %.o: %.c ui-%.c ui-%.h version.h Makefile
-	@printf "$(LOGFORMAT)" +object "$@" "$(MODE)"
-	@$(CC) $(CFLAGS) $(DEPFLAGS) $(DEFINES) -c $< -o $@
-
-#--------------------------
-
-$(C_OBJECTS): %.o: %.c version.h Makefile $(TEXT_FILES)
-	@printf "$(LOGFORMAT)" object "$@" "$(MODE)"

=== debian/changelog ===
wit (3.01a-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    (Closes: #1098097)

 -- Adrian Bunk <bunk@debian.org>  Sat, 25 Oct 2025 16:12:17 +0300

wit (3.01a-5) unstable; urgency=medium

  * d/control:
    - Bump Standards-Version to 4.7.0.
    - Switch from pkg-config to pkgconf.
  * d/copyright:
    - Add myself.
  * d/watch:
    - Bump to version 4.
    - Scan for source release. (Closes: #1061072)
  * d/source/lintian-overrides:
    - Suppress openpgp check for d/watch.

 -- Aloïs Micard <creekorful@debian.org>  Tue, 13 Aug 2024 16:20:11 +0200

wit (3.01a-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Eliminate bashisms in autopkgtest. (Closes: #1033515)

 -- Bastian Germann <bage@debian.org>  Wed, 29 Mar 2023 22:34:46 +0200

wit (3.01a-4) unstable; urgency=medium

  * Add autopkgtests. (Closes: #999455)

 -- Aloïs Micard <creekorful@debian.org>  Thu, 11 Nov 2021 13:57:57 +0100

wit (3.01a-3) unstable; urgency=medium

  * d/control:
    - Adopt the package (Closes: #930303)
    - Use debhelper-compat.
    - Bump debhelper-compat to 13.
    - Bump Standards-Version to 4.6.0
    - Add Rules-Requires-Root.
  * d/rules:
    - Enable hardening=+bindnow.
    - Fix FTCBFS: Pass cross flags to makefile. (Closes: #977479)
      + Thanks Helmut Grohne. :)
  * d/patches/multiarch-libc.patch:
    - Refresh patch following Ben Morris changes. (Closes: #927786)
  * Add d/upstream/metadata.

 -- Aloïs Micard <creekorful@debian.org>  Wed, 10 Nov 2021 14:24:59 +0100

wit (3.01a-2) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible. (Closes: #911804)

 -- Michael Stapelberg <stapelberg@debian.org>  Thu, 25 Oct 2018 15:31:08 +0200

wit (3.01a-1) unstable; urgency=medium

  * remove debian/gbp.conf to disable pristine-tar
  * update README.source for new upstream version
  * New upstream version 3.01a
  * update debian patches
  * d/rules: clean trailing whitespace
  * update URLs
  * priority extra is replaced by priority optional
  * add patch multiarch-libc.patch by Helmut Grohne (Closes: #911683)
  * compat 11
  * bump standards-version to 4.1.4

 -- Michael Stapelberg <stapelberg@debian.org>  Tue, 23 Oct 2018 18:20:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,23 @@
 Source: wit
 Section: utils
-Priority: extra
-Maintainer: Michael Stapelberg <stapelberg@debian.org>
-Build-Depends: debhelper (>= 8.0.0), dpkg-dev (>= 1.16.1~), libmhash-dev, libbz2-dev, libfuse-dev, zlib1g-dev
-Standards-Version: 3.9.4
-Homepage: http://wit.wiimm.de/
-Vcs-Git: git://anonscm.debian.org/collab-maint/wit.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/wit.git;a=summary
+Priority: optional
+Maintainer: Aloïs Micard <creekorful@debian.org>
+Build-Depends: debhelper-compat (= 13),
+               dpkg-dev (>= 1.16.1~),
+               libbz2-dev,
+               libfuse-dev,
+               libmhash-dev,
+               pkgconf,
+               zlib1g-dev
+Standards-Version: 4.7.0
+Homepage: https://wit.wiimm.de/
+Vcs-Git: https://salsa.debian.org/debian/wit.git
+Vcs-Browser: https://salsa.debian.org/debian/wit
+Rules-Requires-Root: binary-targets
 
 Package: wit
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: manipulate Wii and GameCube ISO images and WBFS containers
  Wiimms ISO Tools is a set of command line tools to manipulate Wii and GameCube
  ISO images and WBFS containers. The toolset consists of the following tools:

=== debian/rules ===
--- 
+++ 
@@ -16,11 +16,37 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
+include /usr/share/dpkg/architecture.mk
+
+export DEB_CFLAGS_MAINT_APPEND = -std=gnu17
+
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
+CROSS_FLAGS =
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+CROSS_FLAGS += PRE=$(DEB_HOST_GNU_TYPE)-
+ifeq ($(DEB_HOST_ARCH_OS),linux)
+CROSS_FLAGS += SYSTEM_LINUX=1
+ifeq ($(DEB_HOST_ARCH_CPU),amd64)
+CROSS_FLAGS += SYSTEM=x86_64
+else
+ifeq ($(DEB_HOST_ARCH_CPU),i386)
+CROSS_FLAGS += SYSTEM=i386
+else
+CROSS_FLAGS += SYSTEM=linux
+endif
+endif
+else
+CROSS_FLAGS += SYSTEM=unix
+endif
+endif
+
 # The Makefile doesn’t use CPPFLAGS
 export XDEF=$(shell dpkg-buildflags --get CPPFLAGS)
+
+# hardening
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 override_dh_auto_clean:
 	$(MAKE) clean+
@@ -31,16 +57,21 @@
 override_dh_auto_test:
 
 override_dh_auto_build:
-	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr HAVE_ZLIB=1
-	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr doc
+	# Build targetting /usr...
+	$(MAKE) INSTALL_PATH=/usr HAVE_ZLIB=1 $(CROSS_FLAGS)
+	$(MAKE) INSTALL_PATH=/usr doc
 
 override_dh_auto_install:
+	# ... and then recreate install.sh with a new INSTALL_PATH
+	rm -f templates.sed
 	mkdir -p $(CURDIR)/debian/wit/usr/bin
 	mkdir -p $(CURDIR)/debian/wit/usr/share
-	$(MAKE) INSTALL_PATH=$(CURDIR)/debian/wit/usr install
+	$(MAKE) install.sh INSTALL_PATH=$(CURDIR)/debian/wit/usr
+	# Manually call ./install.sh to avoid rebuilding
+	./install.sh --make
 
 override_dh_installchangelogs:
 	dh_installchangelogs doc/HISTORY.txt
 
 %:
-	dh $@ 
+	dh $@

=== debian/watch ===
version=4
https://download.wiimm.de/source/wiimms-iso-tools/ wiimms-iso-tools.source-([^-]+).txz
